package org.gcube.dataharvest.dao;

import java.util.Date;
import java.util.List;

import org.gcube.dataharvest.datamodel.HarvestedData;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author Eric Perrone (ISTI - CNR)
 * @author Luca Frosini (ISTI - CNR)
 */
public class DatabaseManager {
	
	private static Logger logger = LoggerFactory.getLogger(DatabaseManager.class);
	
	public void insertMonthlyData(Date from, Date to, List<HarvestedData> data, boolean updateFlag) {
		Dao dao = null;
		try {
			dao = dbConnect();
			dao.insertMonthlyMeasure(data, from, to, updateFlag);
		} catch(Exception e) {
			logger.error("", e);
		} finally {
			if(dao != null) {
				try {
					dao.disconnect();
				} catch(DaoException e) {
					logger.error("", e);
				}
			}
		}
	}
	
	public Dao dbConnect() throws DaoException {
		DatabaseParameterRetriever dde = new DatabaseParameterRetriever();
		DatabaseConnectionData dcd = dde.retrieveDatabaseInfo();
		Dao dao = new Dao();
		dao.init();
		dao.connect(dcd.getURI(), dcd.getUser(), dcd.getPassword());
		return dao;
	}
}
